<template>
  <div>
    <div>
      <h2>Search and add a pin</h2>
      <label>
        <gmap-autocomplete
          @place_changed='setPlace'>
        </gmap-autocomplete>
        <button @click='addMarker'>Add</button>   <br> Appuyer deux fois sur la carte pour rajouter un point </br>
      </label>
      <br/>

    </div>
    <br>
    <gmap-map
      v-if="center != null"
      :center='center'
      :zoom='12'
      style='width:100%;  height: 400px;'
      ref='mymap' 
    >
      <gmap-marker 
        :key='index'
        v-for='(m, index) in markers'
        :clickable='true'
        :position='m.position'
        @click='center=m.position'/>
      ></gmap-marker>
    </gmap-map>
  </div>
</template>

<script>

export default {
  name: 'GoogleMap',
  data () {
    return {
      center: { lat: 45.508, lng: -73.587 },
      markers: [],
      places: [],
      currentPlace: null
    }
  },

  mounted () {
    this.geolocate()
    this.$refs.mymap.$mapPromise.then((mymap) => {
      mymap.addListener('click', e => {
        mymap.panTo(e.latLng)
        console.log(mymap.mapUrl)
        var st = mymap.mapUrl.split('=')
        console.log(st)
        var st2 = st[1].split('&')
        console.log(st2)
        var final = st2[0].split(',')
        var latitude = parseFloat(final[0])
        var longitude = parseFloat(final[1])
        const marker = {
          lat: latitude,
          lng: longitude
        }
        this.markers.push({ position: marker })
        this.center = marker
        this.currentPlace = null
        console.log('click')
      })
    })
  },
  computed: {
    markers: function () {
      return this.$store.getters.markers
    },
    center: function () {
      return this.$store.getters.center
    },
    places: function () {
      return this.$store.getters.places
    },
    currentPlace: function () {
      return this.$store.getters.currentPlace
    }
  },
  methods: {
    setPlace (place) {
      this.$store.dispatch('setCurrentPlace', place)
      // this.currentPlace = place
    },
    setCenter (center) {
      this.$store.dispatch('setCenter', center)
    },
    addMarker () {
      if (this.currentPlace) {
        const marker = {
          lat: this.currentPlace.geometry.location.lat(),
          lng: this.currentPlace.geometry.location.lng()
        }
        this.$store.dispatch('addMarker', { position: marker })
        // this.markers.push({ position: marker })
        this.$store.dispatch('addPlace', this.currentPlace)
        // this.places.push(this.currentPlace)
        this.$store.dispatch('setCenter', marker)
        // this.center = marker
        this.$store.dispatch('setCurrentPlace', null)
        // this.currentPlace = null
      }
    },
    geolocate: function () {
      navigator.geolocation.getCurrentPosition(position => {
        this.$store.dispatch('setCenter', {
          lat: position.coords.latitude,
          lng: position.coords.longitude
        })
        /*
        var center = {
          lat: position.coords.latitude,
          lng: position.coords.longitude
        }
        */
      })
    }
  }
}
</script>
